dhtmlxGantt mit Vue.js

Diese Anleitung setzt Grundkenntnisse in Vue voraus. Falls Sie neu bei Vue sind, empfehlen wir Ihnen die Vue 3 Dokumentation für einen schnellen Einstieg.

DHTMLX Gantt funktioniert gut mit Vue. Ein passendes Beispiel finden Sie auf GitHub: DHTMLX Gantt mit Vue Demo.

Ein Projekt erstellen

Stellen Sie sicher, dass Node.js installiert ist, bevor Sie ein neues Projekt starten.

Um ein Vue-Projekt zu erstellen, führen Sie folgenden Befehl aus:

npm create vue@latest

Dieser Befehl installiert und startet create-vue, das offizielle Tool zum Erstellen von Vue-Projekten. Weitere Informationen finden Sie im Vue.js Quick Start.

Installation der Abhängigkeiten

Navigieren Sie anschließend in Ihr App-Verzeichnis. Nennen wir das Projekt gantt-vue:

cd gantt-vue

Installieren Sie dann die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager:

  • Für yarn:
yarn install
yarn dev
  • Für npm:
npm install
npm run dev

Ihr Vue-Projekt sollte jetzt unter http://localhost:5173 laufen.

Gantt Vue App läuft

Gantt erstellen

Um DHTMLX Gantt zum Projekt hinzuzufügen, stoppen Sie zunächst die laufende App mit Strg+C im Terminal. Installieren Sie dann das Gantt-Paket.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek können über npm/yarn aus unserem privaten Repository installiert werden. Folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion haben, installieren Sie sie mit einem der folgenden Befehle:

  • Mit npm:
npm install @dhx/trial-gantt
  • Mit yarn:
yarn add @dhx/trial-gantt

Alternativ können Sie, da das Zip-Paket der Bibliothek als npm-Modul strukturiert ist, es aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie eine Vue-Komponente, um Gantt in Ihre App einzubetten. Legen Sie eine neue Datei namens Gantt.vue im Verzeichnis src/components/ an.

Importieren der Quelldateien

Öffnen Sie Gantt.vue und importieren Sie die Gantt-Quelldateien. Beachten Sie den Unterschied je nach Installationsmethode:

  • Wenn Sie aus einem lokalen Ordner installiert haben, verwenden Sie:

Gantt.vue

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Wenn Sie die Trial-Version installiert haben, verwenden Sie:

Gantt.vue

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

Diese Anleitung verwendet die Trial-Version.

Container festlegen und Gantt hinzufügen

Um Gantt auf der Seite anzuzeigen, geben Sie das Containerelement an. So sieht es aus:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

Damit der Gantt-Container den gesamten Body ausfüllt, entfernen Sie die Standard-Styles aus main.css in src/assets und fügen Sie Folgendes hinzu:

src/assets/main.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Schritt 3. Gantt in die App einbinden

Fügen Sie als Nächstes die Gantt-Komponente in Ihre App ein. Öffnen Sie src/App.vue und ersetzen Sie den Standardinhalt durch:

src/App.vue

<script>
import Gantt from "./components/Gantt.vue";
 
export default {
  components: { Gantt }
};
</script>   <template> <Gantt/> </template>

Nach dem Starten der App sollte ein leerer Gantt angezeigt werden:

Gantt Vue Init

Schritt 4. Daten bereitstellen

Um Aufgaben im Gantt anzuzeigen, stellen Sie einen Datensatz bereit. Erstellen Sie eine Datei data.js im Verzeichnis src/ mit folgenden Daten:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Übergeben Sie diese Daten als Props an die Gantt-Komponente in App.vue:

App.vue

<script>
import Gantt from "./components/Gantt.vue";
import { getData } from "./data";
 
export default {
  components: { Gantt },
  data() {
    return {
      tasks: getData(),
    };
  },
};
</script>   <template> <Gantt :tasks="tasks" /> </template>

Verwenden Sie dann diese Props mit gantt.parse() in der Gantt-Komponente:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  props: ["tasks"],
 
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
    gantt.parse(this.tasks);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

Wenn Sie die App neu laden, wird Gantt nun mit Aufgaben angezeigt:

Gantt Aufgaben

Schritt 5. Daten speichern

Um Änderungen im Gantt zu verfolgen, verwenden Sie einen dataProcessor-Handler, der die Kommunikation mit Ihrem Backend verwaltet. Dieser Handler kann eine Funktion oder ein Router-Objekt sein. dhtmlxGantt unterstützt Promise-Antworten vom Handler, was eine ordnungsgemäße Verarbeitung von Aktionen gewährleistet.

Erstellen Sie einen DataProcessor mit createDataProcessor() und erfassen Sie Änderungen wie folgt:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Falls Ihr Backend beim Erstellen neuer Datensätze die Task-IDs ändert (was in vielen Systemen üblich ist), stellen Sie sicher, dass Ihr Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt. So kann Gantt den Datensatz mit der neuen Datenbank-ID aktualisieren. Weitere Informationen finden Sie unter server side integration.

Damit ist Ihr Vue Gantt-Setup abgeschlossen. Sie können das vollständige Demo auf GitHub erkunden: https://github.com/DHTMLX/vue-gantt-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass Gantt selbst keinen Schutz vor Bedrohungen wie SQL-Injection, XSS oder CSRF-Angriffen bietet. Die Sicherheit Ihrer Anwendung liegt in der Verantwortung der Backend-Entwickler.

Lesen Sie den Artikel Application Security, um mehr über gängige Schwachstellen zu erfahren und wie Sie Ihre App absichern können.

Zurück nach oben

dhtmlxGantt mit React

Dieses Tutorial zeigt, wie Sie das JS DHTMLX Gantt in React-Anwendungen verwenden. Für die offizielle React Gantt-Komponente lesen Sie bitte den Artikel React Gantt.

Es ist hilfreich, ein grundlegendes Verständnis von React Konzepten und Mustern zu haben, bevor Sie mit dieser Anleitung arbeiten. Wenn Sie neu bei React sind, empfiehlt es sich, die React-Dokumentation für eine einsteigerfreundliche Einführung zu lesen.

DHTMLX Gantt funktioniert gut mit React. Ein entsprechendes Beispiel finden Sie auf GitHub hier: DHTMLX Gantt mit React Demo.

Projekt erstellen

Bevor Sie ein neues Projekt erstellen, stellen Sie sicher, dass Node.js installiert ist.

Um schnell ein grundlegendes React-Projekt einzurichten, führen Sie folgenden Befehl aus:

npx create-vite my-react-gantt-app --template react

Installation der Abhängigkeiten

Navigieren Sie anschließend in Ihren Projektordner. Angenommen, Ihr Projekt heißt my-react-gantt-app, führen Sie aus:

cd my-react-gantt-app

Installieren Sie dann die Abhängigkeiten und starten Sie den Entwicklungsserver. Je nach Paketmanager verwenden Sie:

  • mit yarn:
yarn install
yarn dev
  • mit npm:
npm install
npm run dev

Ihre React-App sollte jetzt unter http://localhost:5173 erreichbar sein.

Gantt React app running

Gantt erstellen

Als Nächstes holen wir uns den DHTMLX Gantt-Code. Stoppen Sie zunächst die laufende App durch Drücken von Strg+C im Terminal. Installieren Sie dann das Gantt-Paket.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Bitte folgen Sie dieser Anleitung, um Zugang zu erhalten.

Sobald Sie die Evaluierungsversion haben, installieren Sie sie mit diesen Befehlen:

  • für npm:
npm install @dhx/trial-gantt
  • für yarn:
yarn add @dhx/trial-gantt

Alternativ, da das Bibliotheks-Zip-Paket als npm-Modul strukturiert ist, können Sie es auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie nun eine React-Komponente, um Gantt in Ihre App zu integrieren. Fügen Sie eine neue Datei mit dem Namen Gantt.jsx im Verzeichnis src/ hinzu.

Importieren der Quelldateien

Öffnen Sie Gantt.jsx und importieren Sie die Gantt-Quelldateien. Beachten Sie Folgendes:

  • Wenn Sie das Gantt-Paket aus einem lokalen Ordner installiert haben, sehen Ihre Imports so aus:

Gantt.jsx

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Wenn Sie die Trial-Version installiert haben, verwenden Sie diese Importpfade:

Gantt.jsx

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In dieser Anleitung verwenden wir die Trial-Version.

Container festlegen und Gantt einbinden

Um Gantt auf der Seite darzustellen, wird ein Container-Element benötigt. Die Datei Gantt.jsx sollte Folgendes enthalten:

Gantt.jsx

import { useEffect, useRef } from "react"; import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView() {   let container = useRef();  
  useEffect(() => {     let gantt = Gantt.getGanttInstance();     gantt.init(container.current);  
    return () => {       gantt.destructor();       container.current.innerHTML = "";     };   }, []);  
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>; }

Schritt 3. Gantt in die App einbinden

Fügen Sie als Nächstes die Gantt-Komponente in Ihre App ein. Öffnen Sie src/app.jsx und ersetzen Sie den Standardinhalt durch:

src/app.jsx

import Gantt from "./Gantt";
 
function App() {
  return <Gantt/>;
}
 
export default App;

Um sicherzustellen, dass der Gantt-Container den gesamten Body ausfüllt, entfernen Sie die Standard-Styles aus index.css in src/ und fügen Sie Folgendes hinzu:

src/index.css

html,
body,
#root {
  height: 100%;
  padding: 0;
  margin: 0;
}

Wenn Sie die App erneut starten, sollte ein leerer Gantt-Chart auf der Seite erscheinen:

Gantt React init

Schritt 4. Daten bereitstellen

Um Aufgaben im Gantt anzuzeigen, stellen Sie einen Datensatz bereit. Erstellen Sie eine Datei data.js in src/ mit folgendem Inhalt:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Übergeben Sie diese Daten als Props an die Gantt-Komponente in App.jsx:

App.jsx

import Gantt from "./Gantt";
import { getData } from "./data.js";
 
function App() {
  return <Gantt tasks={getData()} />;
}
 
export default App;

Verwenden Sie dann die Props innerhalb der gantt.parse()-Methode in der Gantt-Komponente:

Gantt.jsx

import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView(props) {
  let container = useRef();
 
  useEffect(() => {
    let gantt = Gantt.getGanttInstance();
    gantt.init(container.current);
    gantt.parse(props.tasks);  
    return () => {
      gantt.destructor();
      container.current.innerHTML = "";
    };
  }, []);
 
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>;
}

Nach dem Neuladen der App sollte das Gantt-Diagramm mit Aufgaben angezeigt werden:

Gantt tasks

Schritt 5. Daten speichern

Um Änderungen im Gantt zu verarbeiten, können Sie einen dataProcessor verwenden, der die Kommunikation mit Ihrem Backend ermöglicht. Der dataProcessor kann als Funktion oder Router-Objekt definiert werden. dhtmlxGantt unterstützt Promise-Antworten vom Handler und ermöglicht so eine korrekte Verarbeitung von Aktionen.

Erstellen Sie einen DataProcessor mit createDataProcessor() und hören Sie Änderungen wie folgt ab:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Wenn Ihr Backend nach dem Erstellen eines Eintrags eine neue ID vergibt (übliches Verhalten), stellen Sie sicher, dass das Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt, damit Gantt den Eintrag entsprechend aktualisieren kann. Weitere Details finden Sie unter server side integration.

Mit dieser Einrichtung ist Ihr React Gantt einsatzbereit. Sie können das vollständige Demo auf GitHub ansehen: https://github.com/DHTMLX/react-gantt-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass Gantt selbst keinen Schutz gegen Bedrohungen wie SQL-Injection, XSS oder CSRF-Angriffe bietet. Die Sicherheit der Anwendung liegt in der Verantwortung der Entwickler, die das Backend verwalten.

Lesen Sie den Artikel Application Security für Einblicke in gängige Schwachstellen und Empfehlungen zur Erhöhung der Sicherheit Ihrer App.

Zurück nach oben

dhtmlxGantt mit Angular

Diese Anleitung setzt grundlegende Kenntnisse der Angular-Konzepte und -Muster voraus. Falls Sie eine Auffrischung benötigen, finden Sie im Angular-Handbuch ein hilfreiches Einstiegstutorial.

DHTMLX Gantt funktioniert reibungslos mit Angular. Ein entsprechendes Beispiel finden Sie auf GitHub: DHTMLX Gantt with Angular Demo.

Projekt erstellen

Bevor Sie ein neues Projekt erstellen, stellen Sie sicher, dass Angular CLI und Node.js installiert sind.

ng new my-angular-gantt-app

Dieser Befehl richtet alle notwendigen Tools und Abhängigkeiten ein, sodass keine weiteren Installationsbefehle erforderlich sind.

Installation der Abhängigkeiten

Navigieren Sie anschließend in Ihr App-Verzeichnis:

cd my-angular-gantt-app

Starten Sie die App mit einem der folgenden Befehle:

yarn start

oder

npm start

Ihre App sollte nun unter http://localhost:4200 erreichbar sein.

Gantt Angular app running

Gantt erstellen

Im nächsten Schritt fügen Sie den DHTMLX Gantt-Code hinzu. Stoppen Sie zunächst die App mit Strg+C in der Kommandozeile und fahren Sie dann mit der Installation des Gantt-Pakets fort.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion von Gantt haben, installieren Sie sie mit einem der folgenden Befehle:

  • für npm:
npm install @dhx/trial-gantt
  • für yarn:
yarn add @dhx/trial-gantt

Alternativ können Sie das Zip-Paket, das als npm-Modul strukturiert ist, auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie eine Komponente, um Gantt in Ihre Anwendung zu integrieren. Legen Sie dazu einen gantt-Ordner im Verzeichnis src/app/ an. Fügen Sie zwei Dateien hinzu: gantt.component.ts und gantt.component.css.

Importieren der Quelldateien

Öffnen Sie gantt.component.ts und importieren Sie die Gantt-Quelldateien. Beachten Sie den Unterschied je nach Installationsmethode:

  • Wenn Sie aus einem lokalen Ordner installiert haben, sehen die Importe so aus:

gantt.component.ts

import { Gantt } from 'dhtmlx-gantt';

gantt.component.css

@import "@dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Wenn Sie die Trial-Version verwenden, sollten die Importe wie folgt aussehen:

gantt.component.ts

import { Gantt } from '@dhx/trial-gantt';

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In diesem Tutorial wird die trial-Version verwendet.

Die Datei gantt.component.ts dient als Vorlage für die Gantt-Komponente. Fügen Sie folgenden Code hinzu:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.init(this.ganttContainer.nativeElement);
 
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

Die Methode ngOnInit() initialisiert Gantt, und ngOnDestroy() sorgt für das Aufräumen, indem beim Entfernen der Komponente gantt.destructor() aufgerufen wird.

Die Styles für Gantt kommen in gantt.component.css. Ein einfaches Setup könnte so aussehen:

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
.gantt-chart {
    position: relative;
    width: 100%;
    height: 600px;
}

Schritt 3. Gantt zur App hinzufügen

Fügen Sie nun die Gantt-Komponente in Ihre App ein. Öffnen Sie src/app/app.component.ts und ersetzen Sie den Standardinhalt durch:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'DHTMLX Gantt with Angular';
}

Erstellen Sie app.module.ts im Verzeichnis src/app/ und binden Sie die GanttComponent wie folgt ein:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { GanttComponent } from './gantt/gantt.component';
 
@NgModule({
  declarations: [AppComponent, GanttComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

Ersetzen Sie in src/app/app.component.html den Standardinhalt durch:

src/app/app.component.html

<gantt></gantt>

Ersetzen Sie abschließend den Inhalt von src/main.ts durch:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

Wenn Sie die App jetzt starten, sollte ein leerer Gantt-Chart angezeigt werden:

Gantt Angular init

Schritt 4. Daten bereitstellen

Um Daten in Angular Gantt zu laden, müssen Task- und Link-Services hinzugefügt werden. Definieren Sie zuvor die Modelle für Tasks und Links.

Erstellen Sie die Task- und Link-Modelle mit folgenden Befehlen:

ng generate class models/task --skip-tests
ng generate class models/link --skip-tests

Fügen Sie in models/task.ts Folgendes hinzu:

models/task.ts

export class Task {
    id!: number;
    start_date!: string;
    text!: string;
    progress!: number;
    duration!: number;
    parent!: number;
}

Fügen Sie in models/link.ts Folgendes hinzu:

models/link.ts

export class Link {
     id!: number;
    source!: number;
    target!: number;
    type!: string;
}

Erstellen Sie als nächstes Task- und Link-Services. Services in Angular sind Klassen, die für bestimmte Aufgaben oder Features zuständig sind und bei Bedarf injiziert werden können.

Erzeugen Sie die Services mit:

ng generate service services/task --flat --skip-tests
ng generate service services/link --flat --skip-tests

In services/task.service.ts fügen Sie Folgendes hinzu:

services/task.service.ts

import { Injectable } from '@angular/core';
import { Task } from '../models/task';
 
@Injectable()
export class TaskService {
    get(): Promise<Task[]>{
        return Promise.resolve([
            { id: 1, text: 'Task #1', start_date: '2023-04-15 00:00', 
                duration: 3, progress: 0.6, parent: 0 },
            { id: 2, text: 'Task #2', start_date: '2023-04-18 00:00', 
                duration: 3, progress: 0.4, parent: 0 }
        ]);
    }
}

In services/link.service.ts fügen Sie Folgendes hinzu:

services/link.service.ts

import { Injectable } from '@angular/core';
import { Link } from '../models/link';
 
@Injectable()
export class LinkService {
    get(): Promise<Link[]> {
        return Promise.resolve([
            { id: 1, source: 1, target: 2, type: '0' }
        ]);
    }
}

Der @Injectable()-Decorator ermöglicht es Angular, die Services über das Dependency-Injection-System zu instanziieren. Die get()-Methoden liefern aktuell fest kodierte Daten als Promise zurück, können aber angepasst werden, um Daten vom Server zu laden.

Um diese Services in der Gantt-Komponente zu verwenden, importieren Sie sie in gantt.component.ts:

gantt.component.ts

import {TaskService} from "../services/task.service";
import {LinkService} from "../services/link.service";

Fügen Sie die Services als Provider im @Component-Decorator hinzu:

gantt.component.ts

@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})

Dadurch wird mit jeder neuen GanttComponent eine neue Instanz jedes Service erstellt.

Fügen Sie einen Konstruktor hinzu, um die Services zu injizieren:

gantt.component.ts

constructor(private taskService: TaskService, private linkService: LinkService) { }

Aktualisieren Sie ngOnInit(), um das Datumsformat zu konfigurieren, Gantt zu initialisieren und die Daten aus den Services zu laden:

gantt.component.ts

let gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttContainer.nativeElement);
 
Promise.all([this.taskService.get(), this.linkService.get()])
    .then( ([data, links]) => {
        gantt.parse({ data, links });
    });
this._gantt = gantt;

Die vollständige gantt.component.ts-Datei sieht dann so aus:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { TaskService } from '../services/task.service';
import { LinkService } from '../services/link.service';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
    constructor(private taskService: TaskService, private linkService: LinkService) { }
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.config.date_format = '%Y-%m-%d %H:%i';
        gantt.init(this.ganttContainer.nativeElement);
        Promise.all([this.taskService.get(), this.linkService.get()])
            .then(([data, links]) => {
                gantt.parse({ data, links });
            });
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

Nach dem Neuladen der App-Seite sollte der Gantt-Chart mit Tasks gefüllt angezeigt werden:

Gantt Angular events

Schritt 5. Daten speichern

Um Änderungen im Gantt zu verfolgen, können Sie einen dataProcessor-Handler verwenden, der die Kommunikation mit dem Server-Backend ermöglicht. Dieser Handler kann entweder als Funktion oder als Router-Objekt eingerichtet werden. dhtmlxGantt unterstützt das Zurückgeben eines Promise vom Handler, sodass Gantt das Abschließen einer Aktion korrekt behandeln kann.

Sie können einen DataProcessor mit der createDataProcessor()-API-Methode erstellen und Änderungen wie folgt erfassen:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Falls Ihr Service die Task-ID nach dem Hinzufügen eines neuen Eintrags ändert (was üblich ist), stellen Sie sicher, dass Ihr Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt. Dadurch kann Gantt den Datensatz mit der neuen Datenbank-ID aktualisieren. Weitere Details finden Sie unter server side information.

Damit ist Ihr Angular Gantt komplett eingerichtet. Sie können das vollständige Demo auf GitHub erkunden.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass Gantt selbst keinen Schutz gegen Bedrohungen wie SQL-Injections oder XSS- und CSRF-Angriffe bietet. Die Sicherheit Ihrer Anwendung liegt in der Verantwortung der Backend-Entwickler.

Lesen Sie den Artikel Application Security, um die anfälligsten Bereiche der Komponente und Maßnahmen zur Verbesserung der Sicherheit Ihrer Anwendung kennenzulernen.

Zurück nach oben

dhtmlxGantt mit Svelte

Diese Anleitung setzt grundlegende Kenntnisse der Svelte-Konzepte und -Muster voraus. Falls nicht, findest du ein hilfreiches Einstiegs-Tutorial in der Svelte-Dokumentation.

DHTMLX Gantt funktioniert gut mit Svelte. Ein funktionierendes Beispiel findest du auf GitHub: DHTMLX Gantt mit Svelte Demo.

Projekt erstellen

Bevor du ein neues Projekt startest, solltest du idealerweise Vite (optional) und Node.js installiert haben.

Um ein Svelte-Projekt einzurichten, verwenden wir Vite. Führe diesen Befehl aus:

npm create vite@latest

Weitere Details findest du im entsprechenden Artikel.

Installation der Abhängigkeiten

Navigiere anschließend in dein App-Verzeichnis. Wir nennen das Projekt gantt-svelte und wählen die Option svelte aus. Dann führe aus:

cd gantt-svelte

Nun installiere die Abhängigkeiten und starte die App mit deinem bevorzugten Paketmanager:

  • Für yarn, führe aus:
yarn install
yarn dev
  • Für npm, führe aus:
npm install
npm run dev

Dein Svelte-Projekt sollte jetzt unter http://localhost:5173 laufen.

Gantt Svelte App läuft

Gantt erstellen

Um DHTMLX Gantt hinzuzufügen, stoppe zunächst die App mit Strg+C im Terminal. Fahre dann mit der Installation des Gantt-Pakets fort.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Bitte folge dieser Anleitung, um Zugriff zu erhalten.

Sobald du die Evaluierungsversion hast, installiere sie mit:

  • Für npm:
npm install @dhx/trial-gantt
  • Für yarn:
yarn add @dhx/trial-gantt

Alternativ, da das ZIP-Paket der Bibliothek als npm-Modul strukturiert ist, kannst du sie auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstelle als Nächstes eine Svelte-Komponente, um Gantt in deiner App einzubinden. Lege eine neue Datei namens Gantt.svelte im src/-Ordner an.

Quell-Dateien importieren

Öffne Gantt.svelte und importiere die Gantt-Quelldateien. Beachte dabei:

  • Wenn du das Gantt-Paket aus einem lokalen Ordner installiert hast, sehen deine Importe so aus:

Gantt.svelte

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Wenn du die Trial-Version installiert hast, verwende diese Importe:

Gantt.svelte

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

Diese Anleitung verwendet die Trial-Version.

Container festlegen und Gantt hinzufügen

Um Gantt auf der Seite anzuzeigen, definiere einen Container für die Komponente. Hier ein Beispiel:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

Damit der Gantt-Container den gesamten Body ausfüllt, entferne Standard-Styles aus app.css im src/-Ordner und füge Folgendes hinzu:

src/app.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Schritt 3. Gantt zur App hinzufügen

Füge nun die Gantt-Komponente in die App ein. Öffne src/App.svelte und ersetze den Standardinhalt mit:

src/App.svelte

<script>
  import Gantt from "./Gantt.svelte";
</script>
 
<Gantt/>

Nach dem Starten der App sollte nun ein leerer Gantt-Chart angezeigt werden:

Gantt Svelte Init

Schritt 4. Daten bereitstellen

Um den Gantt zu befüllen, stelle Daten bereit. Erstelle eine Datei data.js in src/ und füge Folgendes hinzu:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Übergebe diese Daten als Props an die Gantt-Komponente in App.svelte:

App.svelte

<script>
  import Gantt from "./Gantt.svelte";
  import { getData } from "./data.js";
</script>   <Gantt tasks={getData()} />

Nutze dann die Props innerhalb der Gantt-Komponente mit gantt.parse():

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    export let tasks;
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
        gantt.parse(tasks);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

Nach dem Neuladen der App sollte nun ein Gantt-Chart mit Aufgaben angezeigt werden:

Gantt Aufgaben

Schritt 5. Daten speichern

Um Änderungen im Gantt zu verfolgen, kannst du einen dataProcessor-Handler verwenden. Dieser erleichtert die Kommunikation mit dem Backend und kann als Funktion oder Router-Objekt definiert werden. dhtmlxGantt unterstützt Promise-Antworten, um Aktionen korrekt zu verarbeiten.

Erstelle einen DataProcessor mit createDataProcessor(), um Änderungen wie folgt abzufangen:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Falls dein Backend nach dem Erstellen neuer Datensätze die Task-IDs ändert, stelle sicher, dass das Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt, damit Gantt den Datensatz entsprechend aktualisieren kann. Weitere Details zur Server-seitigen Integration findest du hier.

Damit ist dein Svelte Gantt-Setup bereit. Du kannst das vollständige Demo auf GitHub erkunden: https://github.com/DHTMLX/svelte-gantt-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Es ist wichtig zu beachten, dass Gantt keinen eingebauten Schutz gegen Bedrohungen wie SQL-Injection, XSS oder CSRF-Angriffe bietet. Die Absicherung deiner Anwendung gegen solche Risiken liegt in der Verantwortung der Backend-Entwickler.

Weitere Informationen zu potenziellen Schwachstellen und empfohlenen Sicherheitspraktiken findest du im Artikel Application Security.

Zurück nach oben